ES6学习笔记(十四)Generator函数

清明时节雨纷纷,路上行人欲断魂。

借问酒家何处有,牧童遥指杏花村。

二零一九年农历三月初一,清明节。

1.简介

1.1.基本概念

Generator 函数也是 ES6 提供的一种异步编程解决方案,据说在Promise没有诞生之前就靠Generator,但由于用起来比较困难而被取代了。

Generator 函数有多种理解角度。语法上,首先可以把它理解成,Generator 函数是一个状态机封装了多个内部状态

执行 Generator 函数会返回一个遍历器对象,也就是说,Generator 函数除了状态机,还是一个遍历器对象生成函数。返回的遍历器对象,可以依次遍历 Generator 函数内部的每一个状态

形式上,Generator 函数是一个普通函数,但是有两个特征

一是,function关键字与函数名之间有一个星号

二是,函数体内部使用yield表达式定义不同的内部状态yield在英语里的意思就是“产出”)。

1 function* helloWorldGenerator() {
2     yield 'hello';//hello状态
3     yield 'world';//world状态
4     return 'ending';//结束执行的状态
5 }
6 
7 var hw = helloWorldGenerator();

上面代码定义了一个 Generator 函数helloWorldGenerator,它内部有两个yield表达式(helloworld),即该函数有三个状态:hello,world 和 return 语句(结束执行)。

然后,Generator 函数的调用方法与普通函数一样,也是在函数名后面加上一对圆括号。不同的是,调用 Generator 函数后,该函数并不执行返回的也不是函数运行结果而是一个指向内部状态的指针对象,也就是上一章介绍的遍历器对象(Iterator Object)。

下一步,必须调用遍历器对象的next方法,使得指针移向下一个状态。也就是说,每次调用next方法,内部指针就从函数头部或上一次停下来的地方开始执行,直到遇到下一个yield表达式(或return语句)为止。换言之,Generator 函数是分段执行的,yield表达式是暂停执行的标记,而next方法可以恢复执行

 1 function* helloWorldGenerator() {
 2     console.log('第1次执行next()');
 3     yield 'hello';//hello状态
 4     console.log('第2次执行next()');
 5     console.log('加点中间函数');
 6     yield 'world';//world状态
 7     console.log('第3次执行next()');
 8     console.log('中间过程');
 9     return 'ending';//结束执行的状态
10 }
11 
12 var hw = helloWorldGenerator();
13 
14 console.log(hw.next());
15 // 第1次执行next()
16 // { value: 'hello', done: false }
17 console.log(hw.next());
18 // 第2次执行next()
19 // 加点中间函数
20 // { value: 'world', done: false }
21 console.log(hw.next());
22 // 第3次执行next()
23 // 中间过程
24 // { value: 'ending', done: true }
25 console.log(hw.next());
26 // { value: undefined, done: true }

上面代码中一共调用4此next()函数

第一次调用,执行了第一个yield表达式及其之前的部分。next方法返回一个对象,它的value属性就是当前yield表达式的值hellodone属性的值false,表示遍历还没有结束。

第二次调用,执行了第一个yield表达式结束到第二个yield表达式的部分,即Generator 函数从上次yield表达式停下的地方,一直执行到下一个yield表达式。next()方法返回值一样。

第三次调用,和第二次一样,还是从上次结束的地方到第三个yield表达式结束,但是没有第三个表达式,一直执行到return语句(如果没有return语句,就执行到函数结束)。

第四次调用,此时 Generator 函数已经运行完毕,next方法返回对象的value属性为undefineddone属性为true。以后再调用next方法,返回的都是这个值。

总结一下:

  • yield表达式就像函数中的断点,每次执行到断点停止,并且记住状态,下次从老地方继续。
  • 调用 Generator 函数,返回一个遍历器对象,代表 Generator 函数的内部指针。
  • 以后,每次调用遍历器对象的next方法,就会返回一个有着valuedone两个属性的对象。
  • value属性表示当前的内部状态的值,是yield表达式后面那个表达式的值;done属性是一个布尔值,表示是否遍历结束。

ES6 没有规定,function关键字与函数名之间的星号,写在哪个位置,所以随便啦。

1.2.yield 表达式

由于 Generator 函数返回的遍历器对象,只有调用next方法才会遍历下一个内部状态,所以其实提供了一种可以暂停执行的函数。yield表达式就是暂停标志

遍历器对象的next方法的运行逻辑如下。

(1)遇到yield表达式,就暂停执行后面的操作,并将紧跟在yield后面的那个表达式的值,作为返回的对象的value属性值。

(2)下一次调用next方法时,再继续往下执行,直到遇到下一个yield表达式。(3)如果没有再遇到新的yield表达式,就一直运行到函数结束,直到return语句为止,并将return语句后面的表达式的值,作为返回的对象的value属性值。

(4)如果该函数没有return语句,则返回的对象的value属性值为undefined

需要注意的是,yield表达式后面的表达式,只有当调用next方法、内部指针指向该语句时才会执行,因此等于为 JavaScript 提供了手动的“惰性求值”(Lazy Evaluation)的语法功能。

function* gen() {
  yield  123 + 456;
}

上面代码中,yield后面的表达式123 + 456,不会立即求值,只会在next方法将指针移到这一句时,才会求值。

yield表达式与return语句既有相似之处,也有区别。

相似之处在于,都能返回紧跟在语句后面的那个表达式的值。

区别在于每次遇到yield,函数暂停执行,下一次再从该位置继续向后执行,而return语句不具备位置记忆的功能。

一个函数里面,只能执行一次(或者说一个)return语句,但是可以执行多次(或者说多个)yield表达式。

正常函数只能返回一个值,因为只能执行一次returnGenerator 函数可以返回一系列的值,因为可以有任意多个yield

从另一个角度看,也可以说 Generator 生成了一系列的值,这也就是它的名称的来历(英语中,generator 这个词是“生成器”的意思)。

Generator 函数可以不用yield表达式,这时就变成了一个单纯的暂缓执行函数

 1 function* f() {
 2     console.log('执行了!')
 3   }
 4   
 5   var generator = f();
 6   
 7   setTimeout(function () {
 8     console.log(generator.next());
 9   }, 2000);
10 //   执行了!
11 // { value: undefined, done: true }

上面代码中,函数f如果是普通函数,在为变量generator赋值时就会执行。但是,函数f是一个 Generator 函数,就变成只有调用next方法时,函数f才会执行。

另外需要注意yield表达式只能用在 Generator 函数里面,用在其他地方都会报错。

例如:

 1 var arr = [1, [[2, 3], 4], [5, 6]];
 2 
 3 var flat = function* (a) {
 4   a.forEach(function (item) {
 5     if (typeof item !== 'number') {
 6       yield* flat(item);
 7     } else {
 8       yield item;
 9     }
10   });
11 };
12 
13 for (var f of flat(arr)){
14   console.log(f);
15 }

上面代码也会产生句法错误,因为forEach方法的参数是一个普通函数,但是在里面使用了yield表达式(这个函数里面还使用了yield*表达式,详细介绍见后文)。就像await关键字一样,一种修改方法是改用for循环。

另外yield表达式如果用在另一个表达式之中,必须放在圆括号里面

function* demo() {
  console.log('Hello' + yield); // SyntaxError
  console.log('Hello' + yield 123); // SyntaxError

  console.log('Hello' + (yield)); // OK
  console.log('Hello' + (yield 123)); // OK
}

yield表达式用作函数参数或放在赋值表达式的右边,可以不加括号。

function* demo() {
  foo(yield 'a', yield 'b'); // OK
  let input = yield; // OK
}

1.3.与 Iterator 接口的关系

由于任意对象的Symbol.iterator方法等于该对象的遍历器生成函数。调用该函数会返回该对象的一个遍历器对象。

由于Generator函数就是遍历器生成函数,所以可以吧Generator赋值给对象的Symbol.iterator属性,从而使得该对象具有Iterator接口。

var myIterator = {};
myIterator[Symbol.iterator] = function* () {
    yield 1;
    yield 2;
    yield 3;
};
console.log([...myIterator]);//[ 1, 2, 3 ]

上面代码中,Generator 函数赋值给Symbol.iterator属性,从而使得myIterable对象具有了 Iterator 接口,可以被...运算符遍历了。

Generator 函数执行后,返回一个遍历器对象。该对象本身也具有Symbol.iterator属性,执行后返回自身。

function* gen(params) {
    //
}

var g = gen();
console.log(g[Symbol.iterator]() === g);//true

上面代码中,gen是一个 Generator 函数,调用它会生成一个遍历器对象g。它的Symbol.iterator属性,也是一个遍历器对象生成函数,执行后返回它自己。

2.next 方法的参数

yield表达式本身没有返回值,或者说总是返回undefinednext方法可以带一个参数,该参数就会被当作上一个yield表达式的返回值。

 1 function* f() {
 2   for(var i = 0; true; i++) {
 3     var reset = yield i;
 4     if(reset) { i = -1; }
 5   }
 6 }
 7 
 8 var g = f();
 9 
10 g.next() // { value: 0, done: false }
11 g.next() // { value: 1, done: false }
12 g.next(true) // { value: 0, done: false }

上面代码先定义了一个可以无限运行的 Generator 函数f,如果next方法没有参数,每次运行到yield表达式,变量reset的值总是undefined。当next方法带一个参数true时,变量reset就被重置为这个参数(即true),因此i会等于-1,下一轮循环就会从-1开始递增。

这个功能有很重要的语法意义。

一般来说,Generator 函数从暂停状态到恢复运行,它的上下文状态(context)是不变的。

通过next方法的参数,就有办法在 Generator 函数开始运行之后,继续向函数体内部注入值。也就是说,可以在 Generator 函数运行的不同阶段,从外部向内部注入不同的值,从而调整函数行为。

 1 function* foo(x) {
 2   var y = 2 * (yield (x + 1));
 3   var z = yield (y / 3);
 4   return (x + y + z);
 5 }
 6 
 7 var a = foo(5);
 8 a.next() // Object{value:6, done:false}
 9 a.next() // Object{value:NaN, done:false}
10 a.next() // Object{value:NaN, done:true}
11 
12 var b = foo(5);
13 b.next() // { value:6, done:false }
14 b.next(12) // { value:8, done:false }
15 b.next(13) // { value:42, done:true }

上面代码中,

第二次运行next方法的时候不带参数,导致 y 的值等于2 * undefined(即NaN),除以 3 以后还是NaN,因此返回对象的value属性也等于NaN

第三次运行Next方法的时候不带参数,所以z等于undefined,返回对象的value属性等于5 + NaN + undefined,即NaN

如果向next方法提供参数,返回结果就完全不一样了。

上面代码第一次调用bnext方法时,返回x+1的值6

第二次调用next方法,将上一次yield表达式的值设为12,因此y等于24,返回y / 3的值8

第三次调用next方法,将上一次yield表达式的值设为13,因此z等于13,这时x等于5y等于24,所以return语句的值等于42

这个过程貌似有点绕,按照从右往左的执行顺序:

第一次调用next()方法时,先执行等号右边的x + 1计算,然后yield表达式返回,所以第一次总是返回6;

第二次调用next()方法时,先执行 2 * yield表达式的值,然后赋值给y,再执行 y / 3, 然后然后yield表达式返回,此时需要上一次的状态值来运算,所以不知道时就返回undefined / 3 = NaN;

第三次调用next()方法时,先执行z的赋值操作,然后return返回x + y + z,此时也需要上一次的状态值来运算,不知道时就返回5 + NaN + undefined。

总结一下:next()方法的参数为上一次的状态值,就像Promise()中串行回调时then()方法的参数表示上一次的回调返回值一样,需要被用于下一次执行时需要这个参数

注意,由于next方法的参数表示上一个yield表达式的返回值,所以在第一次使用next方法时,数是无效的。V8 引擎直接忽略第一次使用next方法时的参数,只有从第二次使用next方法开始,参数才是有效的。从语义上讲,第一个next方法用来启动遍历器对象,所以不用带有参数

再看一个通过next方法的参数,向 Generator 函数内部输入值的例子。

 1 function* dataConsumer() {
 2   console.log('Started');
 3   console.log(`1. ${yield}`);
 4   console.log(`2. ${yield}`);
 5   return 'result';
 6 }
 7 
 8 let genObj = dataConsumer();
 9 genObj.next();
10 // Started
11 genObj.next('a')
12 // 1. a
13 genObj.next('b')
14 // 2. b

上面代码是一个很直观的例子,每次通过next方法向 Generator 函数输入值,然后打印出来。

如果想要第一次调用next方法时,就能够输入值,可以在 Generator 函数外面再包一层。

 1 function wrapper(generatorFunction) {
 2   return function (...args) {
 3     let generatorObject = generatorFunction(...args);
 4     generatorObject.next();
 5     return generatorObject;
 6   };
 7 }
 8 
 9 const wrapped = wrapper(function* () {
10   console.log(`First input: ${yield}`);
11   return 'DONE';
12 });
13 
14 wrapped().next('hello!')
15 // First input: hello!

上面代码中,Generator 函数如果不用wrapper先包一层,是无法第一次调用next方法,就输入参数的。

3.for...of 循环

for...of循环可以自动遍历 Generator 函数运行时生成的Iterator对象,且此时不再需要调用next方法。

 1 function* foo() {
 2   yield 1;
 3   yield 2;
 4   yield 3;
 5   yield 4;
 6   yield 5;
 7   return 6;
 8 }
 9 
10 for (let v of foo()) {
11   console.log(v);
12 }
13 // 1 2 3 4 5

上面代码使用for...of循环,依次显示 5 个yield表达式的值。这里需要注意,一旦next方法的返回对象的done属性为truefor...of循环就会中止,且不包含该返回对象,所以上面代码的return语句返回的6不包括在for...of循环之中

利用for...of循环,可以写出遍历任意对象(object)的方法。原生的 JavaScript 对象没有遍历接口,无法使用for...of循环,通过 Generator 函数为它加上这个接口,就可以用了。

 1 function* objectEntries(obj) {
 2   let propKeys = Reflect.ownKeys(obj);
 3 
 4   for (let propKey of propKeys) {
 5     yield [propKey, obj[propKey]];
 6   }
 7 }
 8 
 9 let jane = { first: 'Jane', last: 'Doe' };
10 
11 for (let [key, value] of objectEntries(jane)) {
12   console.log(`${key}: ${value}`);
13 }
14 // first: Jane
15 // last: Doe

上面代码中,对象jane原生不具备 Iterator 接口,无法用for...of遍历。这时,我们通过 Generator 函数objectEntries为它加上遍历器接口,就可以用for...of遍历了。加上遍历器接口的另一种写法是,将 Generator 函数加到对象的Symbol.iterator属性上面。

 1 function* objectEntries() {
 2   let propKeys = Object.keys(this);
 3 
 4   for (let propKey of propKeys) {
 5     yield [propKey, this[propKey]];
 6   }
 7 }
 8 
 9 let jane = { first: 'Jane', last: 'Doe' };
10 
11 jane[Symbol.iterator] = objectEntries;
12 
13 for (let [key, value] of jane) {
14   console.log(`${key}: ${value}`);
15 }
16 // first: Jane
17 // last: Doe

除了for...of循环以外,扩展运算符(...)、解构赋值和Array.from方法内部调用的,都是遍历器接口。这意味着,它们都可以将 Generator 函数返回的 Iterator 对象,作为参数。

 1 function* numbers () {
 2   yield 1
 3   yield 2
 4   return 3
 5   yield 4
 6 }
 7 
 8 // 扩展运算符
 9 [...numbers()] // [1, 2]
10 
11 // Array.from 方法
12 Array.from(numbers()) // [1, 2]
13 
14 // 解构赋值
15 let [x, y] = numbers();
16 x // 1
17 y // 2
18 
19 // for...of 循环
20 for (let n of numbers()) {
21   console.log(n)
22 }
23 // 1
24 // 2

4.Generator.prototype.throw()

Generator 函数返回的遍历器对象,都有一个throw方法,可以在函数体外抛出错误,然后在 Generator 函数体内捕获。

 1 var g = function* () {
 2   try {
 3     yield;
 4   } catch (e) {
 5     console.log('内部捕获', e);
 6   }
 7 };
 8 
 9 var i = g();
10 i.next();
11 
12 try {
13   i.throw('a');
14   i.throw('b');
15 } catch (e) {
16   console.log('外部捕获', e);
17 }
18 // 内部捕获 a
19 // 外部捕获 b

上面代码中,遍历器对象i连续抛出两个错误。第一个错误被 Generator 函数体内的catch语句捕获。i第二次抛出错误,由于 Generator 函数内部的catch语句已经执行过了,不会再捕捉到这个错误了,所以这个错误就被抛出了 Generator 函数体,被函数体外的catch语句捕获。

throw方法可以接受一个参数,该参数会被catch语句接收,建议抛出Error对象的实例。

var g = function* () {
  try {
    yield;
  } catch (e) {
    console.log(e);
  }
};

var i = g();
i.next();
i.throw(new Error('出错了!'));
// Error: 出错了!(…)

注意,不要混淆遍历器对象的throw方法和全局的throw命令。上面代码的错误,是用遍历器对象的throw方法抛出的,而不是用throw命令抛出的。后者只能被函数体外的catch语句捕获。

如果 Generator 函数内部没有部署try...catch代码块,那么throw方法抛出的错误,将被外部try...catch代码块捕获。

如果 Generator 函数内部和外部,都没有部署try...catch代码块,那么程序将报错,直接中断执行。

var gen = function* gen(){
  yield console.log('hello');
  yield console.log('world');
}

var g = gen();
g.next();
g.throw();
// hello
// Uncaught undefined

上面代码中,g.throw抛出错误以后,没有任何try...catch代码块可以捕获这个错误,导致程序报错,中断执行。

throw方法抛出的错误要被内部捕获,前提是必须至少执行过一次next方法。

function* gen() {
  try {
    yield 1;
  } catch (e) {
    console.log('内部捕获');
  }
}

var g = gen();
g.throw(1);
// Uncaught 1

上面代码中,g.throw(1)执行时,next方法一次都没有执行过。这时,抛出的错误不会被内部捕获,而是直接在外部抛出,导致程序出错。这种行为其实很好理解,因为第一次执行next方法,等同于启动执行 Generator 函数的内部代码,否则 Generator 函数还没有开始执行,这时throw方法抛错只可能抛出在函数外部。

throw方法被捕获以后,会附带执行下一条yield表达式。也就是说,会附带执行一次next方法。

 1 var gen = function* gen(){
 2   try {
 3     yield console.log('a');
 4   } catch (e) {
 5     // ...
 6   }
 7   yield console.log('b');
 8   yield console.log('c');
 9 }
10 
11 var g = gen();
12 g.next() // a
13 g.throw() // b
14 g.next() // c

上面代码中,g.throw方法被捕获以后,自动执行了一次next方法,所以会打印b。另外,也可以看到,只要 Generator 函数内部部署了try...catch代码块,那么遍历器的throw方法抛出的错误,不影响下一次遍历。

另外,throw命令与g.throw方法是无关的,两者互不影响。

 1 var gen = function* gen(){
 2   yield console.log('hello');
 3   yield console.log('world');
 4 }
 5 
 6 var g = gen();
 7 g.next();
 8 
 9 try {
10   throw new Error();
11 } catch (e) {
12   g.next();
13 }
14 // hello
15 // world

上面代码中,throw命令抛出的错误不会影响到遍历器的状态,所以两次执行next方法,都进行了正确的操作。

这种函数体内捕获错误的机制,大大方便了对错误的处理。多个yield表达式,可以只用一个try...catch代码块来捕获错误。如果使用回调函数的写法,想要捕获多个错误,就不得不为每个函数内部写一个错误处理语句,现在只在 Generator 函数内部写一次catch语句就可以了。

Generator 函数体外抛出的错误,可以在函数体内捕获;反过来,Generator 函数体内抛出的错误,也可以被函数体外的catch捕获。

 1 function* foo() {
 2   var x = yield 3;
 3   var y = x.toUpperCase();
 4   yield y;
 5 }
 6 
 7 var it = foo();
 8 
 9 it.next(); // { value:3, done:false }
10 
11 try {
12   it.next(42);
13 } catch (err) {
14   console.log(err);
15 }

上面代码中,第二个next方法向函数体内传入一个参数 42,数值是没有toUpperCase方法的,所以会抛出一个 TypeError 错误,被函数体外的catch捕获。

一旦 Generator 执行过程中抛出错误,且没有被内部捕获,就不会再执行下去了。如果此后还调用next方法,将返回一个value属性等于undefineddone属性等于true的对象,即 JavaScript 引擎认为这个 Generator 已经运行结束了。

5.Generator.prototype.return() 

 Generator 函数返回的遍历器对象,还有一个return方法,可以返回给定的值,并且终结遍历 Generator 函数。

 1 function* gen() {
 2   yield 1;
 3   yield 2;
 4   yield 3;
 5 }
 6 
 7 var g = gen();
 8 
 9 g.next()        // { value: 1, done: false }
10 g.return('foo') // { value: "foo", done: true }
11 g.next()        // { value: undefined, done: true }

上面代码中,遍历器对象g调用return方法后,返回值的value属性就是return方法的参数foo。并且,Generator 函数的遍历就终止了,返回值的done属性为true,以后再调用next方法,done属性总是返回true

如果return方法调用时,不提供参数,则返回值的value属性为undefined

function* gen() {
  yield 1;
  yield 2;
  yield 3;
}

var g = gen();

g.next()        // { value: 1, done: false }
g.return() // { value: undefined, done: true }

如果 Generator 函数内部有try...finally代码块,且正在执行try代码块,那么return方法会推迟到finally代码块执行完再执行。finally代码块是不会被打断的。

 1 function* numbers () {
 2   yield 1;
 3   try {
 4     yield 2;
 5     yield 3;
 6   } finally {
 7     yield 4;
 8     yield 5;
 9   }
10   yield 6;
11 }
12 var g = numbers();
13 g.next() // { value: 1, done: false }
14 g.next() // { value: 2, done: false }
15 g.return(7) // { value: 4, done: false }
16 g.next() // { value: 5, done: false }
17 g.next() // { value: 7, done: true }

上面代码中,调用return方法后,就开始执行finally代码块,然后等到finally代码块执行完,再执行return方法。

6.next()、throw()、return() 的共同点

next()throw()return()这三个方法本质上是同一件事,可以放在一起理解。它们的作用都是让 Generator 函数恢复执行,并且使用不同的语句替换yield表达式。

next()是将yield表达式替换成一个值。

 1 const g = function* (x, y) {
 2   let result = yield x + y;
 3   return result;
 4 };
 5 
 6 const gen = g(1, 2);
 7 gen.next(); // Object {value: 3, done: false}
 8 
 9 gen.next(1); // Object {value: 1, done: true}
10 // 相当于将 let result = yield x + y
11 // 替换成 let result = 1;

throw()是将yield表达式替换成一个throw语句。

gen.throw(new Error('出错了')); // Uncaught Error: 出错了
// 相当于将 let result = yield x + y
// 替换成 let result = throw(new Error('出错了'));

return()是将yield表达式替换成一个return语句。

gen.return(2); // Object {value: 2, done: true}
// 相当于将 let result = yield x + y
// 替换成 let result = return 2;

7.yield* 表达式 

 如果在 Generator 函数内部,调用另一个 Generator 函数,默认情况下是没有效果的。

 1 function* foo() {
 2   yield 'a';
 3   yield 'b';
 4 }
 5 
 6 function* bar() {
 7   yield 'x';
 8   foo();
 9   yield 'y';
10 }
11 
12 for (let v of bar()){
13   console.log(v);
14 }
15 // "x"
16 // "y"

上面代码中,foobar都是 Generator 函数,在bar里面调用foo,是不会有效果的。

这个就需要用到yield*表达式,用来在一个 Generator 函数里面执行另一个 Generator 函数

从语法角度看,如果yield表达式后面跟的是一个遍历器对象,需要在yield表达式后面加上星号,表明它返回的是一个遍历器对象。这被称为yield*表达式。

yield*后面的 Generator 函数(没有return语句时),等同于在 Generator 函数内部,部署一个for...of循环。

8.作为对象属性的 Generator 函数

如果一个对象的属性是 Generator 函数,可以简写成下面的形式。

let obj = {
  * myGeneratorMethod() {
    ···
  }
};

上面代码中,myGeneratorMethod属性前面有一个星号,表示这个属性是一个 Generator 函数。

它的完整形式如下,与上面的写法是等价的。

let obj = {
  myGeneratorMethod: function* () {
    // ···
  }
};

9.Generator 函数的this 

Generator 函数总是返回一个遍历器,ES6 规定这个遍历器是 Generator 函数的实例,也继承了 Generator 函数的prototype对象上的方法,而不是this对象。

Generator 函数也不能跟new命令一起用,会报错。

10.含义

Generator 与状态机 

Generator 是实现状态机的最佳结构。比如,下面的clock函数就是一个状态机。

var ticking = true;
var clock = function() {
  if (ticking)
    console.log('Tick!');
  else
    console.log('Tock!');
  ticking = !ticking;
}

上面代码的clock函数一共有两种状态(TickTock),每运行一次,就改变一次状态。这个函数如果用 Generator 实现,就是下面这样。

var clock = function* () {
  while (true) {
    console.log('Tick!');
    yield;
    console.log('Tock!');
    yield;
  }
};

上面的 Generator 实现与 ES5 实现对比,可以看到少了用来保存状态的外部变量ticking,这样就更简洁,更安全(状态不会被非法篡改)、更符合函数式编程的思想,在写法上也更优雅。

Generator 之所以可以不用外部变量保存状态,是因为它本身就包含了一个状态信息,即目前是否处于暂停态。

Generator 与协程

协程(coroutine)是一种程序运行的方式,可以理解成“协作的线程”或“协作的函数”。协程既可以用单线程实现,也可以用多线程实现。前者是一种特殊的子例程,后者是一种特殊的线程。

Generator 与上下文

JavaScript 代码运行时,会产生一个全局的上下文环境(context,又称运行环境),包含了当前所有的变量和对象。然后,执行函数(或块级代码)的时候,又会在当前上下文环境的上层,产生一个函数运行的上下文,变成当前(active)的上下文,由此形成一个上下文环境的堆栈(context stack)。

这个堆栈是“后进先出”的数据结构,最后产生的上下文环境首先执行完成,退出堆栈,然后再执行完成它下层的上下文,直至所有代码执行完成,堆栈清空。

Generator 函数不是这样,它执行产生的上下文环境,一旦遇到yield命令,就会暂时退出堆栈,但是并不消失,里面的所有变量和对象会冻结在当前状态。等到对它执行next命令时,这个上下文环境又会重新加入调用栈,冻结的变量和对象恢复执行。

11.应用

Generator 可以暂停函数执行,返回任意表达式的值。这种特点使得 Generator 有多种应用场景。

(1)异步操作的同步化表达 

Generator 函数的暂停执行的效果,意味着可以把异步操作写在yield表达式里面,等到调用next方法时再往后执行。这实际上等同于不需要写回调函数了,因为异步操作的后续操作可以放在yield表达式下面,反正要等到调用next方法时再执行。所以,Generator 函数的一个重要实际意义就是用来处理异步操作,改写回调函数。

 1 function* loadUI() {
 2   showLoadingScreen();
 3   yield loadUIDataAsynchronously();
 4   hideLoadingScreen();
 5 }
 6 var loader = loadUI();
 7 // 加载UI
 8 loader.next()
 9 
10 // 卸载UI
11 loader.next()

上面代码中,第一次调用loadUI函数时,该函数不会执行,仅返回一个遍历器。下一次对该遍历器调用next方法,则会显示Loading界面(showLoadingScreen),并且异步加载数据(loadUIDataAsynchronously)。等到数据加载完成,再一次使用next方法,则会隐藏Loading界面。可以看到,这种写法的好处是所有Loading界面的逻辑,都被封装在一个函数,按部就班非常清晰。

不过Promise方案更加清晰好用。

(2)控制流管理

回调函数

step1(function (value1) {
  step2(value1, function(value2) {
    step3(value2, function(value3) {
      step4(value3, function(value4) {
        // Do something with value4
      });
    });
  });
});

Promise

Promise.resolve(step1)
  .then(step2)
  .then(step3)
  .then(step4)
  .then(function (value4) {
    // Do something with value4
  }, function (error) {
    // Handle any error from step1 through step4
  })
  .done();

上面代码已经把回调函数,改成了直线执行的形式,但是加入了大量 Promise 的语法。Generator 函数可以进一步改善代码运行流程。

function* longRunningTask(value1) {
  try {
    var value2 = yield step1(value1);
    var value3 = yield step2(value2);
    var value4 = yield step3(value3);
    var value5 = yield step4(value4);
    // Do something with value4
  } catch (e) {
    // Handle any error from step1 through step4
  }
}

然后,使用一个函数,按次序自动执行所有步骤。

scheduler(longRunningTask(initialValue));

function scheduler(task) {
  var taskObj = task.next(task.value);
  // 如果Generator函数未结束,就继续调用
  if (!taskObj.done) {
    task.value = taskObj.value
    scheduler(task);
  }
}

注意,上面这种做法,只适合同步操作,即所有的task都必须是同步的,不能有异步操作。因为这里的代码一得到返回值,就继续往下执行,没有判断异步操作何时完成。如果要控制异步的操作流程,详见后面的《异步操作》一章。

(3)部署 Iterator 接口

利用 Generator 函数,可以在任意对象上部署 Iterator 接口。

(4)作为数据结构

Generator 可以看作是数据结构,更确切地说,可以看作是一个数组结构,因为 Generator 函数可以返回一系列的值,这意味着它可以对任意表达式,提供类似数组的接口。

posted @ 2019-04-06 23:20  姬无华  阅读(293)  评论(0编辑  收藏  举报